//-*-c++-*------------------------------------------------------------
//
// File name : bioArithIntegral.h
// Author :    Michel Bierlaire
// Date :      Tue Mar 30 17:33:52 2010
//
//--------------------------------------------------------------------

#ifndef bioArithIntegral_h
#define bioArithIntegral_h


#include "bioArithUnaryExpression.h"

/*!
Class implementing a node of the tree representing an integral between -infty and +infty
*/
class bioArithIntegral : public bioArithUnaryExpression {

public:
  
  bioArithIntegral(bioExpressionRepository* rep,
		   patULong par,
		   patULong left,
		   patString aLiteralName,
		   patError*& err) ;
  
  ~bioArithIntegral() ;

public:
  virtual patString getOperatorName() const;
  virtual patReal getValue(patBoolean prepareGradient, patError*& err)  ;
  virtual bioExpression* getDerivative(patULong aLiteralId, 
				       patError*& err) const ;
  virtual bioArithIntegral* getDeepCopy(bioExpressionRepository* rep,
					patError*& err) const ;
  virtual bioArithIntegral* getShallowCopy(bioExpressionRepository* rep,
					patError*& err) const ;
  virtual patString getCppCode(patString prefix, patError*& err) ;
  virtual patString getSimpleCppCode(patError*& err) ;
  virtual patBoolean isStructurallyZero() const ;
  virtual patString getExpressionString() const ;
  virtual void generateGslFunctions(ostream& str_h, patString prefix, patError*& err) ;
  virtual bioFunctionAndDerivatives* getNumericalFunctionAndGradient(vector<patULong> literalIds, patBoolean computeHessian,patError*& err) ;
public:
  patULong literalId ;
  patString literalName ;

private:
  vector<patULong> theCompositeLiteralsIds ;

};

#endif
