//-*-c++-*------------------------------------------------------------
//
// File name : patAntithetic.h
// Author :    Michel Bierlaire
// Date :      Thu Jun  3 07:09:14 2010
//
//--------------------------------------------------------------------

#ifndef patAntithetic_h
#define patAntithetic_h



/**
   @doc Generate antithetic draws from a symmetric distribution. 
 */

#include <fstream>
#include "patType.h"
#include "patRandomNumberGenerator.h"
class patError ;
class patUniform ;

class patAntithetic: public patRandomNumberGenerator {

 public:
  /**
   */
  patAntithetic(patRandomNumberGenerator* draws, 
		patULong R, 
		patULong s, 
		patBoolean dumpDrawsOnFile,
		patError*& err) ;

  /**
   */
  virtual ~patAntithetic() ;
  /**
   */
  virtual patReal getNextValue(patError*& err) ;

  /**
   */
  virtual patReal getZeroOneDraw(patError*& err)  ;

  virtual patBoolean isSymmetric() const ;

  virtual patBoolean isNormal() const ;


private:
  void generate(patError*& err) ;

 private:
  patRandomNumberGenerator* rndNumberGenerator ;
  ofstream* logFile ;
  patULong nbrOfDraws ;
  patULong nbrOfSeries ;
  vector< vector<patReal> > theDraws ;
  patBoolean first ;
  patULong currentValue ;
  patULong currentSerie ;
};
#endif
