from biogeme import *

## Implements the Box-Cox transform of a variable
# @param x variable to be transformed
# @param lambda parameter of the transformation
# @return The Box-Cox transform, that is
#  \f[ \frac{x^\lambda - 1 }{\lambda} \f] 
# @code
# def boxcox(x,l):
#     return (x**l - 1) / l
# @endcode

def boxcox(x,l) :
    return (x**l - 1) / l
